---
apiVersion: v1
kind: ServiceAccount
metadata:
  name: "{{ capi_cluster }}-auc-sa"
---
apiVersion: rbac.authorization.k8s.io/v1
kind: Role
metadata:
  name: "{{ capi_cluster }}-auc-role"
rules:
  - apiGroups: ["cluster.x-k8s.io"]
    resources: ["machines"]
    verbs: ["get", "list", "watch"]
---
apiVersion: rbac.authorization.k8s.io/v1
kind: RoleBinding
metadata:
  name: "{{ capi_cluster }}-auc-rb"
subjects:
  - kind: ServiceAccount
    name: "{{ capi_cluster }}-auc-sa"
roleRef:
  kind: Role
  name: "{{ capi_cluster }}-auc-role"
  apiGroup: rbac.authorization.k8s.io
---
apiVersion: v1
kind: Secret
metadata:
  name: "{{ capi_cluster }}-auc-credentials"
type: Opaque
data:
  credentials: "{{ [capi_haproxy_dataplane_user, capi_haproxy_dataplane_password] | join(':') | b64encode }}"
---
apiVersion: v1
kind: ConfigMap
metadata:
  name: "{{ capi_cluster }}-auc-scripts"
data:
  apiserver-update.sh: |
    {{ capi_apiserver_update_script | indent(4, false) }}
---
apiVersion: batch/v1
kind: CronJob
metadata:
  name: "{{ capi_cluster }}-auc"
spec:
  schedule: "* * * * *"
  successfulJobsHistoryLimit: 1
  failedJobsHistoryLimit: 1
  concurrencyPolicy: Replace
  jobTemplate:
    spec:
      template:
        spec:
          serviceAccountName: "{{ capi_cluster }}-auc-sa"
          restartPolicy: OnFailure
          containers:
            - name: auc
              image: "{{ capi_apiserver_update_cronjob_image }}"
              command:
                - "/bin/bash"
                - "/etc/scripts/apiserver-update.sh"
              volumeMounts:
                - name: scripts
                  mountPath: /etc/scripts
              env:
                - name: DATAPLANE_API_URL
                  value: "{{ capi_capo_openstack_ext_apiserver_ip }}:{{ capi_haproxy_dataplane_port }}/v3"
                - name: DATAPLANE_API_AUTH
                  valueFrom:
                    secretKeyRef:
                      name: "{{ capi_cluster }}-auc-credentials"
                      key: credentials
                - name: HAPROXY_BACKEND
                  value: k8s-apiserver
                - name: CAPI_CLUSTER_NAME
                  value: "{{ capi_cluster }}"
                - name: CAPI_NAMESPACE
                  value: "{{ capi_kube_namespace }}"
          volumes:
            - name: scripts
              configMap:
                name: "{{ capi_cluster }}-auc-scripts"
                items:
                  - key: apiserver-update.sh
                    path: apiserver-update.sh
